Task (Gradle API 2.14)
Date: 2016-06-14

Package: org.gradle.api

## [Java] Interface Task

- org.gradle.api.Task

- All Superinterfaces:
    ExtensionAware

  A `Task` represents a single atomic piece of work for a build, such as compiling classes or generating javadoc.

  Each task belongs to a Project. You can use the various methods on TaskContainer to create and lookup task instances. For example, TaskContainer.create creates an empty task with the given name. You can also use the `task` keyword in your build file:

       task myTask
       task myTask { configure closure }
       task myType << { task action }
       task myTask(type: SomeType)
       task myTask(type: SomeType) { configure closure }

  Each task has a name, which can be used to refer to the task within its owning project, and a fully qualified path, which is unique across all tasks in all projects. The path is the concatenation of the owning project's path and the task's name. Path elements are separated using the {

  value:
    org.gradle.api.Project#PATH_SEPARATOR} character.

    ### Task Actions

    A `Task` is made up of a sequence of Action objects. When the task is executed, each of the actions is executed in turn, by calling Action.execute. You can add actions to a task by calling doFirst(Action) or doLast(Action).

    Groovy closures can also be used to provide a task action. When the action is executed, the closure is called with the task as parameter. You can add action closures to a task by calling doFirst(groovy.lang.Closure) or doLast(groovy.lang.Closure) or using the left-shift `<<` operator.

    There are 2 special exceptions which a task action can throw to abort execution and continue without failing the build. A task action can abort execution of the action and continue to the next action of the task by throwing a StopActionException. A task action can abort execution of the task and continue to the next task by throwing a StopExecutionException. Using these exceptions allows you to have precondition actions which skip execution of the task, or part of the task, if not true.

    ### Task Dependencies and Task Ordering

    A task may have dependencies on other tasks or might be scheduled to always run after another task. Gradle ensures that all task dependencies and ordering rules are honored when executing tasks, so that the task is executed after all of its dependencies and any "must run after" tasks have been executed.

    Dependencies to a task are controlled using dependsOn(Object...) or setDependsOn(Iterable), and mustRunAfter(Object...), setMustRunAfter(Iterable), shouldRunAfter(Object...) and setShouldRunAfter(Iterable) are used to specify ordering between tasks. You can use objects of any of the following types to specify dependencies and ordering:

    - A `String`, `CharSequence` or `groovy.lang.GString` task path or name. A relative path is interpreted relative to the task's Project. This allows you to refer to tasks in other projects.
    - A Task.
    - A closure. The closure may take a `Task` as parameter. It may return any of the types listed here. Its return value is recursively converted to tasks. A `null` return value is treated as an empty collection.
    - A TaskDependency object.
    - A Buildable object.
    - A `Iterable`, `Collection`, `Map` or array. May contain any of the types listed here. The elements of the iterable/collection/map/array are recursively converted to tasks.
    - A `Callable`. The `call()` method may return any of the types listed here. Its return value is recursively converted to tasks. A `null` return value is treated as an empty collection.
    - An `Object`. The object's `toString()` method is interpreted as a task path or name. The support for custom Objects has been deprecated and will be removed in the next version of Gradle.

    ### Using a Task in a Build File

    #### Dynamic Properties

    A `Task` has 4 'scopes' for properties. You can access these properties by name from the build file or by calling the property(String) method. You can change the value of these properties by calling the setProperty(String, Object) method.

    - The `Task` object itself. This includes any property getters and setters declared by the `Task` implementation class. The properties of this scope are readable or writable based on the presence of the corresponding getter and setter methods.
    - The extensions added to the task by plugins. Each extension is available as a read-only property with the same name as the extension.
    - The convention properties added to the task by plugins. A plugin can add properties and methods to a task through the task's Convention object. The properties of this scope may be readable or writable, depending on the convention objects.
    - The extra properties of the task. Each task object maintains a map of additional properties. These are arbitrary name -> value pairs which you can use to dynamically add properties to a task object. Once defined, the properties of this scope are readable and writable.

    #### Dynamic Methods

    A Plugin may add methods to a `Task` using its Convention object.

    #### Parallel Execution

    By default, tasks are not executed in parallel. Parallel execution can be enabled by the `--parallel` flag when the build is initiated. In parallel mode, the tasks of different projects (i.e. in a multi project build) are able to be executed in parallel. If a task is annotated with ParallelizableTask, it may also be executed in parallel with other tasks of the same project. See ParallelizableTask for more details on writing parallelizable tasks.

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `static class` | `Task.Namer` | A Namer namer for tasks that returns getName().

  - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String` | `TASK_ACTION` |
    `static String` | `TASK_DEPENDS_ON` |
    `static String` | `TASK_DESCRIPTION` |
    `static String` | `TASK_GROUP` |
    `static String` | `TASK_NAME` |
    `static String` | `TASK_OVERWRITE` |
    `static String` | `TASK_TYPE` |

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `Task` | `configure(groovy.lang.Closure configureClosure)`
    `Task` | `deleteAllActions()`
    `Task` | `dependsOn(Object... paths)`
    `boolean` | `dependsOnTaskDidWork()`
    `Task` | `doFirst(Action<? super Task> action)`
    `Task` | `doFirst(groovy.lang.Closure action)`
    `Task` | `doLast(Action<? super Task> action)`
    `Task` | `doLast(groovy.lang.Closure action)`
    `Task` | `finalizedBy(Object... paths)`
    `List<Action<? super Task>>` | `getActions()`
    `AntBuilder` | `getAnt()`
    `Convention` | `getConvention()`
    `Set<Object>` | `getDependsOn()`
    `String` | `getDescription()` Returns the description of this task.
    `boolean` | `getDidWork()`
    `boolean` | `getEnabled()`
    `TaskDependency` | `getFinalizedBy()`
    `String` | `getGroup()` Returns the task group which this task belongs to.
    `TaskInputs` | `getInputs()`
    `Logger` | `getLogger()`
    `LoggingManager` | `getLogging()` Returns the LoggingManager which can be used to control the logging level and standard output/error capture for this task.
    `TaskDependency` | `getMustRunAfter()`
    `String` | `getName()`
    `TaskOutputs` | `getOutputs()`
    `String` | `getPath()`
    `Project` | `getProject()`
    `TaskDependency` | `getShouldRunAfter()`
    `TaskState` | `getState()` Returns the execution state of this task.
    `TaskDependency` | `getTaskDependencies()`
    `File` | `getTemporaryDir()`
    `boolean` | `hasProperty(String propertyName)`
    `Task` | `leftShift(groovy.lang.Closure action)`
    `Task` | `mustRunAfter(Object... paths)`
    `void` | `onlyIf(groovy.lang.Closure onlyIfClosure)`
    `void` | `onlyIf(Spec<? super Task> onlyIfSpec)`
    `Object` | `property(String propertyName)`
    `void` | `setActions(List<Action<? super Task>> actions)`
    `void` | `setDependsOn(Iterable<?> dependsOnTasks)`
    `void` | `setDescription(String description)` Sets a description for this task.
    `void` | `setDidWork(boolean didWork)` Sets whether the task actually did any work.
    `void` | `setEnabled(boolean enabled)`
    `void` | `setFinalizedBy(Iterable<?> finalizedBy)`
    `void` | `setGroup(String group)` Sets the task group which this task belongs to.
    `void` | `setMustRunAfter(Iterable<?> mustRunAfter)`
    `void` | `setOnlyIf(groovy.lang.Closure onlyIfClosure)`
    `void` | `setOnlyIf(Spec<? super Task> onlyIfSpec)`
    `void` | `setProperty(String name, Object value)`
    `void` | `setShouldRunAfter(Iterable<?> shouldRunAfter)`
    `TaskDependency` | `shouldRunAfter(Object... paths)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `interface Comparable` | `compareTo`
    `interface ExtensionAware` | `getExtensions`

- - ### Field Detail

    - #### public static final String TASK_ACTION

    - #### public static final String TASK_DEPENDS_ON

    - #### public static final String TASK_DESCRIPTION

    - #### public static final String TASK_GROUP

    - #### public static final String TASK_NAME

    - #### public static final String TASK_OVERWRITE

    - #### public static final String TASK_TYPE

  - ### Method Detail

    - #### public Task configure(groovy.lang.Closure configureClosure)

      Applies the statements of the closure against this task object. The delegate object for the closure is set to this task.

      Parameters:
        `configureClosure` - The closure to be applied (can be null).
      Returns:
        This task

    - #### public Task deleteAllActions()

      Removes all the actions of this task.

      Returns:
        the task object this method is applied to

    - #### public Task dependsOn(Object... paths)

      Adds the given dependencies to this task. See here for a description of the types of objects which can be used as task dependencies.

      Parameters:
        `paths` - The dependencies to add to this task. The path can be defined by:
    - A `String`, `CharSequence` or `groovy.lang.GString` task path or name. A relative path is interpreted relative to the task's Project. This allows you to refer to tasks in other projects.
    - A Task.
    - A closure. The closure may take a `Task` as parameter. It may return any of the types listed here. Its return value is recursively converted to tasks. A `null` return value is treated as an empty collection.
    - A TaskDependency object.
    - A Buildable object.
    - A `Iterable`, `Collection`, `Map` or array. May contain any of the types listed here. The elements of the iterable/collection/map/array are recursively converted to tasks.
    - A `Callable`. The `call()` method may return any of the types listed here. Its return value is recursively converted to tasks. A `null` return value is treated as an empty collection.
    - An `Object`. The object's `toString()` method is interpreted as a task path or name. The support for custom Objects has been deprecated and will be removed in the next version of Gradle.
    Returns:
      the task object this method is applied to

  - #### public boolean dependsOnTaskDidWork()

    Checks if any of the tasks that this task depends on didWork.

    Returns:
      true if any task this task depends on did work.

  - #### public Task doFirst(Action<? super Task> action)

    Adds the given Action to the beginning of this task's action list.

    Parameters:
      `action` - The action to add
    Returns:
      the task object this method is applied to

  - #### public Task doFirst(groovy.lang.Closure action)

    Adds the given closure to the beginning of this task's action list. The closure is passed this task as a parameter when executed.

    Parameters:
      `action` - The action closure to execute.
    Returns:
      This task.

  - #### public Task doLast(Action<? super Task> action)

    Adds the given Action to the end of this task's action list.

    Parameters:
      `action` - The action to add.
    Returns:
      the task object this method is applied to

  - #### public Task doLast(groovy.lang.Closure action)

    Adds the given closure to the end of this task's action list. The closure is passed this task as a parameter when executed.

    Parameters:
      `action` - The action closure to execute.
    Returns:
      This task.

  - #### @Incubating public Task finalizedBy(Object... paths)

    Adds the given finalizer tasks for this task.

         task taskY {
             finalizedBy "taskX"
         }

    See here for a description of the types of objects which can be used to specify a finalizer task.

    Parameters:
      `paths` - The tasks that finalize this task.
    Returns:
      the task object this method is applied to

  - #### public List<Action<? super Task>> getActions()

    Returns the sequence of Action objects which will be executed by this task, in the order of execution.

    Returns:
      The task actions in the order they are executed. Returns an empty list if this task has no actions.

  - #### public AntBuilder getAnt()

    Returns the `AntBuilder` for this task. You can use this in your build file to execute ant tasks.

    Returns:
      The `AntBuilder`

  - #### public Convention getConvention()

    Returns the Convention object for this task. A Plugin can use the convention object to contribute properties and methods to this task.

    Returns:
      The convention object. Never returns null.

  - #### public Set<Object> getDependsOn()

    Returns the dependencies of this task.

    Returns:
      The dependencies of this task. Returns an empty set if this task has no dependencies.

  - #### public String getDescription()

    Returns the description of this task.

    Returns:
      the description. May return null.

  - #### public boolean getDidWork()

    Checks if the task actually did any work. Even if a Task executes, it may determine that it has nothing to do. For example, a compilation task may determine that source files have not changed since the last time a the task was run.

    Returns:
      true if this task did any work

  - #### public boolean getEnabled()

    Returns if this task is enabled or not.

    See Also:
      setEnabled(boolean)

  - #### @Incubating public TaskDependency getFinalizedBy()

    Returns tasks that finalize this task.

    Returns:
      The tasks that finalize this task. Returns an empty set if there are no finalising tasks for this task.

  - #### public String getGroup()

    Returns the task group which this task belongs to. The task group is used in reports and user interfaces to group related tasks together when presenting a list of tasks to the user.

    Returns:
      The task group for this task. Might be null.

  - #### public TaskInputs getInputs()

    Returns the inputs of this task.

    Returns:
      The inputs. Never returns null.

  - #### public Logger getLogger()

    Returns the logger for this task. You can use this in your build file to write log messages.

    Returns:
      The logger. Never returns null.

  - #### public LoggingManager getLogging()

    Returns the LoggingManager which can be used to control the logging level and standard output/error capture for this task. By default, System.out is redirected to the Gradle logging system at the QUIET log level, and System.err is redirected at the ERROR log level.

    Returns:
      the LoggingManager. Never returns null.

  - #### @Incubating public TaskDependency getMustRunAfter()

    Returns tasks that this task must run after.

    Returns:
      The tasks that this task must run after. Returns an empty set if this task has no tasks it must run after.

  - #### public String getName()

    Returns the name of this task. The name uniquely identifies the task within its Project.

    Returns:
      The name of the task. Never returns null.

  - #### public TaskOutputs getOutputs()

    Returns the outputs of this task.

    Returns:
      The outputs. Never returns null.

  - #### public String getPath()

    Returns the path of the task, which is a fully qualified name for the task. The path of a task is the path of its Project plus the name of the task, separated by `:`.

    Returns:
      the path of the task, which is equal to the path of the project plus the name of the task.

  - #### public Project getProject()

    Returns the Project which this task belongs to.

    Returns:
      The project this task belongs to. Never returns null.

  - #### @Incubating public TaskDependency getShouldRunAfter()

    Returns tasks that this task should run after.

    Returns:
      The tasks that this task should run after. Returns an empty set if this task has no tasks it must run after.

  - #### public TaskState getState()

    Returns the execution state of this task. This provides information about the execution of this task, such as whether it has executed, been skipped, has failed, etc.

    Returns:
      The execution state of this task. Never returns null.

  - #### public TaskDependency getTaskDependencies()

    Returns a TaskDependency which contains all the tasks that this task depends on.

    Returns:
      The dependencies of this task. Never returns null.

  - #### public File getTemporaryDir()

    Returns a directory which this task can use to write temporary files to. Each task instance is provided with a separate temporary directory. There are no guarantees that the contents of this directory will be kept beyond the execution of the task.

    Returns:
      The directory. Never returns null. The directory will already exist.

  - #### public boolean hasProperty(String propertyName)

    Determines if this task has the given property. See here for details of the properties which are available for a task.

    Parameters:
      `propertyName` - The name of the property to locate.
    Returns:
      True if this project has the given property, false otherwise.

  - #### public Task leftShift(groovy.lang.Closure action)

    Adds the given closure to the end of this task's action list. The closure is passed this task as a parameter when executed. You can call this method from your build script using the << left shift operator.

    Parameters:
      `action` - The action closure to execute.
    Returns:
      This task.

  - #### @Incubating public Task mustRunAfter(Object... paths)

    Specifies that this task must run after all of the supplied tasks.

         task taskY {
             mustRunAfter "taskX"
         }

    For each supplied task, this action adds a task 'ordering', and does not specify a 'dependency' between the tasks. As such, it is still possible to execute 'taskY' without first executing the 'taskX' in the example.

    See here for a description of the types of objects which can be used to specify an ordering relationship.

    Parameters:
      `paths` - The tasks this task must run after.
    Returns:
      the task object this method is applied to

  - #### public void onlyIf(groovy.lang.Closure onlyIfClosure)

    Execute the task only if the given closure returns true. The closure will be evaluated at task execution time, not during configuration. The closure will be passed a single parameter, this task. If the closure returns false, the task will be skipped.

    You may add multiple such predicates. The task is skipped if any of the predicates return false.

    Typical usage:`myTask.onlyIf{ dependsOnTaskDidWork() }`

    Parameters:
      `onlyIfClosure` - code to execute to determine if task should be run

  - #### public void onlyIf(Spec<? super Task> onlyIfSpec)

    Execute the task only if the given spec is satisfied. The spec will be evaluated at task execution time, not during configuration. If the Spec is not satisfied, the task will be skipped.

    You may add multiple such predicates. The task is skipped if any of the predicates return false.

    Typical usage (from Java):

        myTask.onlyIf(new Spec<Task>() {
            boolean isSatisfiedBy(Task task) {
               return task.dependsOnTaskDidWork();
            }
         });

    Parameters:
      `onlyIfSpec` - specifies if a task should be run

  - #### public Object property(String propertyName)

    Returns the value of the given property of this task. This method locates a property as follows:

    1. If this task object has a property with the given name, return the value of the property.
    2. If this task has an extension with the given name, return the extension.
    3. If this task's convention object has a property with the given name, return the value of the property.
    4. If this task has an extra property with the given name, return the value of the property.
    5. If not found, throw groovy.lang.MissingPropertyException
    throws:
      MissingPropertyException When the given property is unknown.
    Parameters:
      `propertyName` - The name of the property.
    Returns:
      The value of the property, possibly null.

  - #### public void setActions(List<Action<? super Task>> actions)

    Sets the sequence of Action objects which will be executed by this task.

    Parameters:
      `actions` - The actions.

  - #### public void setDependsOn(Iterable<?> dependsOnTasks)

    Sets the dependencies of this task. See here for a description of the types of objects which can be used as task dependencies.

    Parameters:
      `dependsOnTasks` - The set of task paths.

  - #### public void setDescription(String description)

    Sets a description for this task. This should describe what the task does to the user of the build. The description will be displayed when `gradle tasks` is called.

    Parameters:
      `description` - The description of the task. Might be null.

  - #### public void setDidWork(boolean didWork)

    Sets whether the task actually did any work. Most built-in tasks will set this automatically, but it may be useful to manually indicate this for custom user tasks.

    This is useful when combined with onlyIf { dependsOnTaskDidWork() }.

    Parameters:
      `didWork` - indicates if the task did any work

  - #### public void setEnabled(boolean enabled)

    Set the enabled state of a task. If a task is disabled none of the its actions are executed. Note that disabling a task does not prevent the execution of the tasks which this task depends on.

    Parameters:
      `enabled` - The enabled state of this task (true or false)

  - #### @Incubating public void setFinalizedBy(Iterable<?> finalizedBy)

    Specifies the set of finalizer tasks for this task.

         task taskY {
             finalizedBy = ["taskX1", "taskX2"]
         }

    See here for a description of the types of objects which can be used to specify a finalizer task.

    Parameters:
      `finalizedBy` - The tasks that finalize this task.

  - #### public void setGroup(String group)

    Sets the task group which this task belongs to. The task group is used in reports and user interfaces to group related tasks together when presenting a list of tasks to the user.

    Parameters:
      `group` - The task group for this task. Can be null.

  - #### @Incubating public void setMustRunAfter(Iterable<?> mustRunAfter)

    Specifies the set of tasks that this task must run after.

         task taskY {
             mustRunAfter = ["taskX1", "taskX2"]
         }

    For each supplied task, this action adds a task 'ordering', and does not specify a 'dependency' between the tasks. As such, it is still possible to execute 'taskY' without first executing the 'taskX' in the example.

    See here for a description of the types of objects which can be used to specify an ordering relationship.

    Parameters:
      `mustRunAfter` - The set of task paths this task must run after.

  - #### public void setOnlyIf(groovy.lang.Closure onlyIfClosure)

    Execute the task only if the given closure returns true. The closure will be evaluated at task execution time, not during configuration. The closure will be passed a single parameter, this task. If the closure returns false, the task will be skipped.

    The given predicate replaces all such predicates for this task.

    Parameters:
      `onlyIfClosure` - code to execute to determine if task should be run

  - #### public void setOnlyIf(Spec<? super Task> onlyIfSpec)

    Execute the task only if the given spec is satisfied. The spec will be evaluated at task execution time, not during configuration. If the Spec is not satisfied, the task will be skipped.

    The given predicate replaces all such predicates for this task.

    Parameters:
      `onlyIfSpec` - specifies if a task should be run

  - #### public void setProperty(String name, Object value)

    Sets a property of this task. This method searches for a property with the given name in the following locations, and sets the property on the first location where it finds the property.

    1. The task object itself. For example, the `enabled` project property.
    2. The task's convention object.
    3. The task's extra properties.
    If the property is not found, a groovy.lang.MissingPropertyException is thrown.
    Parameters:
      `name` - The name of the property
      `value` - The value of the property

  - #### @Incubating public void setShouldRunAfter(Iterable<?> shouldRunAfter)

    Specifies the set of tasks that this task should run after.

         task taskY {
             shouldRunAfter = ["taskX1", "taskX2"]
         }

    For each supplied task, this action adds a task 'ordering', and does not specify a 'dependency' between the tasks. As such, it is still possible to execute 'taskY' without first executing the 'taskX' in the example.

    See here for a description of the types of objects which can be used to specify an ordering relationship.

    Parameters:
      `shouldRunAfter` - The set of task paths this task should run after.

  - #### @Incubating public TaskDependency shouldRunAfter(Object... paths)

    Specifies that this task should run after all of the supplied tasks.

         task taskY {
             shouldRunAfter "taskX"
         }

    For each supplied task, this action adds a task 'ordering', and does not specify a 'dependency' between the tasks. As such, it is still possible to execute 'taskY' without first executing the 'taskX' in the example.

    See here for a description of the types of objects which can be used to specify an ordering relationship.

    Parameters:
      `paths` - The tasks this task should run after.
    Returns:
      the task object this method is applied to